    LIST        P=18F2550
            #INCLUDE    <P18F2550.INC>

;*********************************************************************************************
;	 										 
;*********************************************************************************************
;  CONFIG1L            
            CONFIG      USBDIV = 2
            CONFIG      CPUDIV = OSC1_PLL2
            CONFIG      PLLDIV = 5
;  CONFIG1H            
            CONFIG      IESO = OFF
            CONFIG      FCMEN = OFF
            CONFIG      FOSC = HSPLL_HS
;  CONFIG2L            
            CONFIG      VREGEN = ON
            CONFIG      BORV = 3
            CONFIG      BOR = ON
            CONFIG      PWRT = ON
;  CONFIG2H            
            CONFIG      WDTPS = 32768
            CONFIG      WDT = OFF
;  CONFIG3L
            ;  .
;  CONFIG3H            
            CONFIG      MCLRE = OFF
            CONFIG      LPT1OSC = OFF
            CONFIG      PBADEN = OFF
            CONFIG      CCP2MX = ON
;  CONFIG4L            
            CONFIG      DEBUG = OFF
            CONFIG      XINST = OFF
            CONFIG      LVP = OFF
            CONFIG      STVREN = ON
;  CONFIG4H
            ; .
;  CONFIG5L
            CONFIG      CP3 = OFF
            CONFIG      CP2 = OFF
            CONFIG      CP1 = OFF
            CONFIG      CP0 = OFF
;  CONFIG5H            
            CONFIG      CPD = OFF
            CONFIG      CPB = OFF
;  CONFIG6L            
            CONFIG      WRT3 = OFF
            CONFIG      WRT2 = OFF
            CONFIG      WRT1 = OFF
            CONFIG      WRT0 = OFF
;  CONFIG6H            
            CONFIG      WRTD = OFF
            CONFIG      WRTB = OFF
            CONFIG      WRTC = OFF
;  CONFIG7L            
            CONFIG      EBTR3 = OFF
            CONFIG      EBTR2 = OFF
            CONFIG      EBTR1 = OFF
            CONFIG      EBTR0 = OFF
;  CONFIG7H            
            CONFIG      EBTRB = OFF
;*********************************************************************************************	

	cblock	h'100'

	W_temp			;   
	ST_temp			;  

	ARG_L			;    
	ARG_H			;    

	RES0			;   
	RES1			;   , .
	RES2			; (ARG_L:ARG_H)*(ARG_L:ARG_H)=
	RES3			; = RES0:RES1:RES2:RES3

	Byte_0			;   
	Byte_1			;  RES0:RES1:RES2:RES3
	Byte_2			;
	Byte_3			;

	Temp			;  
	Temp_0			;   (,  )
	Temp_1			;  

	Result_L		;   : 
	Result_H		; , , ,
					;   256 . ,  ,
					;     .

	AN0_L			;   
	AN0_H			;   AN_0
	AN1_L			;  
	AN1_H			;   AN_1
	AN2_L			;  
	AN2_H			;   AN_2
	AN3_L			;  
	AN3_H			;   AN_3
	AN4_L			;  
	AN4_H			;   AN_4
	AN8_L			;  
	AN8_H			;   AN_8

	AL				; ,     16- ,
	AH				;   .
	FigSeg			;    .
	A100			;      ,
	A10				;      ,
	A1				;      .
	Key

	State			;  .
	Count			;  .
	Q_Count			;   

	endc


; 					   "State"
new		equ	0		; 1 =   ,
stop	equ 1		; 1 =  256 . 

;*********************************************************************************************
;*	 		  		
;*********************************************************************************************
    org         0x00
    bra	        Start
;*********************************************************************************************
;*	 		 					
;*********************************************************************************************
    org         0x08 
INT
	movwf	W_temp			; ,  PIC18  
	swapf	STATUS,w		; ,  -
	movwf	ST_temp			; "  "
;							;  "swapf"? -     STATUS,
;							     "movwf"   .
;*********************************************************************************************
	clrwdt					;  ""  .
	btfss	PIR1, TMR1IF	;    TMR1?
	bra		ACP				;   ?
	bcf		PIR1, TMR1IF	;   .
	movlw	.254			;     256     
	movwf	TMR1H			; 20 / 256 = 78,125
	movlw	.136			;     78
	movwf	TMR1L			;   .
	bsf		ADCON0, GO_DONE ;  
	bra		End_INT			;     .
ACP
	btfss	PIR1, ADIF		;    ?
	bra		qqw				; -  ,    .
	bcf		PIR1, ADIF		;     .
	dcfsnz	Count			;    256 . 
	bsf		State, stop		;   .
	bsf		State, new		;    .		
;*********************************************************************************************
; 			 
;*********************************************************************************************
	clrf	WREG			;     :
	iorlw	b'11111000'		;       , -
	movwf	PORTC			;    "".
;							       ,  
;							     . 
	
	rlncf	POSTINC0, WREG	;   -     ,
;							     (A100, A10, A1).
	call	Segment			;   7-   ,
	iorlw	b'00000100'		;   "PORTB,2"   .
	movwf	PORTB			;    .
	movff	FigSeg, WREG	;  
	iorlw	b'11111000'		; ,  ,
	movwf	PORTC			;    .
	rrncf	FigSeg			;    
	btfss	FigSeg, 7		; , ,   .
	bra		End_INT	
	lfsr	0, A100			;   ,    :
	movlw	b'00000100'		;    100.
	movwf	FigSeg			;
qqw							;  ,     .
End_INT
	swapf	ST_temp,w		;      
	movwf	STATUS			;  .
	swapf	W_temp,f		;   
	swapf	W_temp,w		; .
	retfie					;    .
;*********************************************************************************************
;     7. .					
;*********************************************************************************************
Segment
	addwf	PCL, f
;			  GFEDC_BA	
	retlw	b'10000000'			; 0
	retlw	b'11110101'			; 1
	retlw	b'01001000'			; 2
	retlw	b'01100000'			; 3
	retlw	b'00110001'			; 4
	retlw	b'00100010'			; 5
	retlw	b'00000010'			; 6
	retlw	b'11110100'			; 7
	retlw	b'00000000'			; 8
	retlw	b'00100000'			; 9
	retlw	b'00010000'			; A
	retlw	b'00000011'			; b
	retlw	b'10001010'			; C
	retlw	b'01000001'			; d
	retlw	b'00001010'			; E
	retlw	b'00011010'			; F
;*********************************************************************************************

;*********************************************************************************************
; 
;*********************************************************************************************
Start
	movlb 1					; 1  			
	clrwdt					;  

	clrf	A1				; 				
	clrf	A10				; 
	clrf	A100			; 
	lfsr	0, A100
	movlw	b'00000100'		;
	movwf	FigSeg			;
	movlw	b'00101111'		; 
	movwf	TRISA			;

	movlw	b'00000100'		; 
	movwf	TRISB			;

	movlw	b'10000000'		; 
	movwf	TRISC			;

	movlw	b'00000111'
	movwf	CMCON
 
	clrf	ADCON0
	movlw	b'00001001'		;   
	movwf	ADCON1			;   
							;  
							;  - Fosc/16, 
							;  
							;  AN0,   
	movlw	b'10001101'
	movwf	ADCON2

	bcf		PIR1, ADIF
	bsf		PIE1, ADIE		;   
	bsf		T1CON,  TMR1ON
	bsf		PIE1,	TMR1IE	;    1,		
	bsf		INTCON, PEIE	;   ,
	bsf		INTCON, GIE		;  .
;*********************************************************************************************
MainLoop
	movlw	b'00000001'		;  ,  AN0
	movwf	ADCON0
	call 	Get_AD_Value
	movff	Result_L, AN0_L
	movff	Result_H, AN0_H

	movlw	b'00000101'		;  ,  AN1
	movwf	ADCON0
	call 	Get_AD_Value
	movff	Result_L, AN1_L
	movff	Result_H, AN1_H

	movlw	b'00001001'		;  ,  AN2
	movwf	ADCON0
	call 	Get_AD_Value
	movff	Result_L, AN2_L
	movff	Result_H, AN2_H

	movlw	b'00001101'		;  ,  AN3
	movwf	ADCON0
	call 	Get_AD_Value
	movff	Result_L, AN3_L
	movff	Result_H, AN3_H

	movlw	b'00010001'		;  ,  AN4
	movwf	ADCON0
	call 	Get_AD_Value
	movff	Result_L, AN4_L
	movff	Result_H, AN4_H

	movlw	b'00100001'		;  ,  AN8
	movwf	ADCON0
	call 	Get_AD_Value
	movff	Result_L, AN8_L
	movff	Result_H, AN8_H

;*************************
	movff	AN8_L, AL	;*
	movff	AN8_H, AH	;*
	call	BIN2DEC3	;*
;*************************

	bra		MainLoop

;*********************************************************************************************
;	 		
;*********************************************************************************************
;       (AN0-AN4,AN8)
;      256 .				
;*********************************************************************************************
Get_AD_Value
	clrf	Byte_0
	clrf	Byte_1
	clrf	Byte_2
	clrf	Byte_3
	clrf	Count
	clrf	State
Get_AD_Value_1
	btfss	State, new		;   .
	bra		Get_AD_Value_1	; 
	bcf		State, new	
	call 	SQUARING		;   ,
	call	SUMMA			; .
	btfss	State, stop		;  256 ?
	bra		Get_AD_Value_1	;  ,  .
	call	SQRT24			;  256  ,
;							         (256),
;							         (Byte_0),  
;							    256 (   - , )
	bcf		STATUS, C		;       (  = 5 ),
	rrcf	Result_H, f		; 5.12 / 1024 = 5 .
	rrcf	Result_L, f		;    ,    = 10 .
	return
SQUARING
;*********************************************************************************************
;      ARG,
;        RES.  				
;*********************************************************************************************
	movff	ADRESH, ARG_H
	movff	ADRESL, ARG_L

	movff	ARG_L, WREG		; ARG_L * ARG_L 
	mulwf	ARG_L			;
 	movff	PRODH,  RES1	; 
	movff	PRODL,  RES0	;PRODL : PRODH

	movff	ARG_H, WREG		; ARG_H * ARG_H 
	mulwf	ARG_H			; 
	movff	PRODH,  RES3	; 
	movff	PRODL,  RES2	;PRODL : PRODH

	movff	ARG_L, 	WREG	; ARG_L * ARG_H 
	mulwf	ARG_H			;			
 
	movff	PRODL, WREG		; 	 
	addwf	RES1,  f		; 
	movff	PRODH, WREG		; 
	addwfc	RES2,  f		; 
	clrf	WREG			; 
	addwfc	RES3,  f		;

	movff	PRODL, WREG		;
	addwf	RES1,  f		;
	movff	PRODH, WREG		;
	addwfc	RES2,  f		;
	clrf	WREG			;
	addwfc	RES3,  f		;
	return					;
;*********************************************************************************************
SUMMA
;*********************************************************************************************
;  RES  Byte,										
;     Byte.  					
;*********************************************************************************************
	movff	RES0,	WREG	; RES0 + Byte_0      
	addwf	Byte_0,	f		; Byte_0
	movff	RES1,	WREG	; C + RES1 + Byte_1  	
	addwfc	Byte_1			; Byte_1
	movff	RES2,	WREG	; C + RES2 + Byte_2  
	addwfc	Byte_2,	f		; Byte_2
	movff	RES3,	WREG	; C + RES3 + Byte_3  
	addwfc	Byte_3			; Byte_3
	return
;*********************************************************************************************
;     
;*********************************************************************************************
BIN2DEC3				;   ,   :				
	clrf	A1			; ,				
	clrf	A10			;  
	clrf	A100		;    AH:AL.
;*********************************************************************************************
;   AH:AL   "02:17",
;   "535"    . 
;   535-100      
;     5 .
;      1  100 
;   535-100-100-100-100-100 = 35
;    100     - 5
;*********************************************************************************************
CV100
	incf	A100,f		;      .
	movlw	.100		; . AH:AL - 00:64 (.100 -   ),
	subwf	AL, f		; AL - .100 ,    AL
	clrf	WREG		;    100  "0",
	subwfb	AH, f		;     ,    "0"   
	bc		CV100		;     100,   .	
	movlw	.100		; , ,     100
	addwf	AL, f		; AH:AL + .100
	clrf	WREG		;  
	addwfc	AH, f		; .
	decf	A100,f		;       A100 ,  .
;*********************************************************************************************
; 535 - 100 - 100 - 100 - 100 - 100 = 35
;    100     - 5.
;      .
;  35 - 10   ,      
; 35 - 10 - 10 - 10 = 5
;   A10     - 3
;*********************************************************************************************
CV10
	incf	A10,f		;      .
	movlw	.10			; . AH:AL - 00:0A (.10 -   ),
	subwf	AL, f		; AL - .10 ,    AL
	clrf	WREG		;    10  "0",
	subwfb	AH, f		;     ,    "0"   
	bc		CV10		;     10,   .
	movlw	.10			; , ,     10
	addwf	AL, f		; AH:AL + .10
	clrf	WREG		;  
	addwfc	AH, f		; .
	decf	A10,f		;       A100 ,  .
;*********************************************************************************************
; 35 - 10 - 10 - 10 = 5
;   A10     - 3
;     
; ,        - A1
; A1 = 5
;*********************************************************************************************
CV1
	movff	AL,A1	; 	
	return
;*********************************************************************************************
SQRT24
;*********************************************************************************************
;    24  ,					
;    - Byte_1, Byte_2, Byte_3,								
;     Result_L, Result_H;  						
;   Temp_0, Temp_1;	
;     "".
;*********************************************************************************************
 	clrf 	Result_H		;   , 
	clrf 	Result_L		;   .
	clrf 	Temp_0			;
	clrf 	Temp_1			;

	movlw 	.12				;    
	movwf 	Q_Count			; 3   8  = 24 , 24/2 = 12 . 

Shift
	rlcf 	Byte_1, f		;      
	rlcf 	Byte_2, f		;   .  
	rlcf 	Byte_3, f 		;  = 4 *  +2    
	rlcf 	Temp_0, f 		; (Temp_0,1)= 4 * (Temp_0,1) + 2   (Byte_n)
	rlcf 	Temp_1, f 		;  
	rlcf 	Byte_1, f		; 		 
	rlcf 	Byte_2, f		; 
	rlcf 	Byte_3, f 		;  
	rlcf 	Temp_0, f 		;  
	rlcf 	Temp_1, f		; "   "

	rlcf 	Result_L, f		;    
	rlcf 	Result_H, f		;  :
	rlcf 	Result_L, f		; 
	rlcf 	Result_H, f		; 
	bcf 	Result_L, 1		; 4*Result_+1 
	bsf 	Result_L, 0		;     . 

SubTest
	movff 	Result_L, WREG	;  
	subwf 	Temp_0,f		; Temp_0,1 < Result_  ??    
	movff 	Result_H, WREG	;  
	subwfb 	Temp_1,f		; 

	bc		Set1			;    
;							  ,   "1"    . 

	movff 	Result_L, WREG	;  " ":
	addwf 	Temp_0,f		;   ,
	movff 	Result_H, WREG	;     
	addwfc 	Temp_1,f		;  ,   
	bra 	Set0			;       "0".
Set1
	bsf 	Result_L, 1		;      "1". 
Set0
	rrcf 	Result_H, f		;  " ":  
	rrcf 	Result_L, f		; Result_0,1 = 2 * Result_0,1
	bcf 	Result_H, 7		;  	 

	decfsz 	Q_Count,f		;   , 
	bra 	Shift			;     , .
;*********************************************************************************************
;				 .
;      (   Temp_0:Temp_1),
;  , ( Result_L:Result_H).
;    ,       -  .
;    ,       -   .
;    ,      .
;*********************************************************************************************
	movff 	Result_L, WREG	;  ,   ?
	subwf 	Temp_0,f		;   ,
	movff 	Result_H, WREG	;  .
	subwfb 	Temp_1,f		; 

	btfss 	STATUS,C		;    ?
	bra 	End_SQRT24		;    ,    .

	incf 	Result_L, f		;     , 
	clrf 	WREG			;  
	addwfc 	Result_H, f		;  .
End_SQRT24
	return					; !!!  .
;*********************************************************************************************

	end						; .